commit 7547bb19a2af0d082a41d425d0bd197360cdf64c
Author: Assos Assos <assos+forge@centrale-marseille.fr>
Date:   Thu Feb 23 00:12:32 2017 +0100

    Weekly update of contrib modules

diff --git a/drupal7/sites/all/modules/captcha/captcha.admin.inc b/drupal7/sites/all/modules/captcha/captcha.admin.inc
index 6878d8e7..ac7dc8ab 100644
--- a/drupal7/sites/all/modules/captcha/captcha.admin.inc
+++ b/drupal7/sites/all/modules/captcha/captcha.admin.inc
@@ -41,7 +41,7 @@ function _captcha_available_challenge_types($add_special_options = TRUE) {
 function captcha_admin_settings() {
   module_load_include('inc', 'captcha');
 
-  // Use javascript for some added usability on admin form.
+  // Use JavaScript for some added usability on admin form.
   drupal_add_js(drupal_get_path('module', 'captcha') . '/captcha.js');
 
   // Configuration of which forms to protect, with what challenge.
diff --git a/drupal7/sites/all/modules/captcha/captcha.inc b/drupal7/sites/all/modules/captcha/captcha.inc
index 934d72f9..4dc6f824 100644
--- a/drupal7/sites/all/modules/captcha/captcha.inc
+++ b/drupal7/sites/all/modules/captcha/captcha.inc
@@ -39,7 +39,7 @@ function captcha_set_form_id_setting($form_id, $captcha_type) {
     db_delete('captcha_points')->condition('form_id', $form_id)->execute();
   }
   // Handle a captcha_type object.
-  elseif (is_object($captcha_type) && isset($captcha_type->module) && isset($captcha_type->captcha_type)) {
+  elseif (is_object($captcha_type) && !empty($captcha_type->module) && !empty($captcha_type->captcha_type)) {
     db_merge('captcha_points')
       ->key(array('form_id' => $form_id))
       ->fields(array('module' => $captcha_type->module, 'captcha_type' => $captcha_type->captcha_type))
@@ -104,7 +104,7 @@ function captcha_get_form_id_setting($form_id, $symbolic = FALSE) {
   if (!$captcha_point) {
     $captcha_point = NULL;
   }
-  elseif ($captcha_point->captcha_type == 'default') {
+  elseif (!empty($captcha_point->captcha_type) && $captcha_point->captcha_type == 'default') {
     if (!$symbolic) {
       list($module, $type) = explode('/', variable_get('captcha_default_challenge', 'captcha/Math'));
       $captcha_point->module = $module;
@@ -114,12 +114,13 @@ function captcha_get_form_id_setting($form_id, $symbolic = FALSE) {
       $captcha_point = 'default';
     }
   }
-  elseif ($captcha_point->module == NULL && $captcha_point->captcha_type == NULL && $symbolic) {
+  elseif (empty($captcha_point->module) && empty($captcha_point->captcha_type) && $symbolic) {
     $captcha_point = 'none';
   }
   elseif ($symbolic) {
     $captcha_point = $captcha_point->module . '/' . $captcha_point->captcha_type;
   }
+
   return $captcha_point;
 }
 
diff --git a/drupal7/sites/all/modules/captcha/captcha.info b/drupal7/sites/all/modules/captcha/captcha.info
index 74cba986..b48d5a75 100644
--- a/drupal7/sites/all/modules/captcha/captcha.info
+++ b/drupal7/sites/all/modules/captcha/captcha.info
@@ -10,9 +10,9 @@ files[] = captcha.admin.inc
 files[] = captcha.install
 files[] = captcha.test
 
-; Information added by Drupal.org packaging script on 2015-03-27
-version = "7.x-1.3"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-1.4"
 core = "7.x"
 project = "captcha"
-datestamp = "1427464219"
+datestamp = "1487198287"
 
diff --git a/drupal7/sites/all/modules/captcha/captcha.js b/drupal7/sites/all/modules/captcha/captcha.js
index e7c469e2..fe3114d1 100644
--- a/drupal7/sites/all/modules/captcha/captcha.js
+++ b/drupal7/sites/all/modules/captcha/captcha.js
@@ -4,7 +4,7 @@
     attach: function (context) {
 
       // Turn off autocompletion for the CAPTCHA response field.
-      // We do it here with Javascript (instead of directly in the markup)
+      // We do it here with JavaScript (instead of directly in the markup)
       // because this autocomplete attribute is not standard and
       // it would break (X)HTML compliance.
       $("#edit-captcha-response").attr("autocomplete", "off");
diff --git a/drupal7/sites/all/modules/captcha/captcha.module b/drupal7/sites/all/modules/captcha/captcha.module
index 945651da..50cbe154 100644
--- a/drupal7/sites/all/modules/captcha/captcha.module
+++ b/drupal7/sites/all/modules/captcha/captcha.module
@@ -157,6 +157,8 @@ function captcha_element_info() {
     '#process' => array('captcha_element_process'),
     // The type of challenge: e.g. 'default', 'none', 'captcha/Math', 'image_captcha/Image'.
     '#captcha_type' => 'default',
+    // Forces captcha validation for all cases if TRUE.
+    '#captcha_always' => FALSE,
     '#default_value' => '',
     // CAPTCHA in admin mode: presolve the CAPTCHA and always show it (despite previous successful responses).
     '#captcha_admin_mode' => FALSE,
@@ -179,15 +181,14 @@ function captcha_element_process($element, &$form_state, $complete_form) {
 
   module_load_include('inc', 'captcha');
 
-  // Add Javascript for general CAPTCHA functionality.
+  // Add JavaScript for general CAPTCHA functionality.
   drupal_add_js(drupal_get_path('module', 'captcha') . '/captcha.js');
 
   // Prevent caching of the page with CAPTCHA elements.
   // This needs to be done even if the CAPTCHA will be ommitted later:
   // other untrusted users should not get a cached page when
   // the current untrusted user can skip the current CAPTCHA.
-  global $conf;
-  $conf['cache'] = FALSE;
+  drupal_page_is_cacheable(FALSE);
 
   // Get the form ID of the form we are currently processing (which is not
   // necessary the same form that is submitted (if any).
@@ -254,7 +255,7 @@ function captcha_element_process($element, &$form_state, $complete_form) {
     'captcha_sid' => $captcha_sid,
   );
 
-  if (_captcha_required_for_user($captcha_sid, $this_form_id) || $element['#captcha_admin_mode']) {
+  if (_captcha_required_for_user($captcha_sid, $this_form_id) || $element['#captcha_admin_mode'] || $element['#captcha_always']) {
     // Generate a CAPTCHA and its solution
     // (note that the CAPTCHA session ID is given as third argument).
     $captcha = module_invoke($captcha_type_module, 'captcha', 'generate', $captcha_type_challenge, $captcha_sid);
@@ -594,7 +595,18 @@ function captcha_validate_case_insensitive_ignore_spaces($solution, $response) {
  *     if the values could not be found, e.g. for a fresh form).
  */
 function _captcha_get_posted_captcha_info($element, $form_state, $this_form_id) {
-  if ($form_state['submitted'] && isset($form_state['captcha_info'])) {
+  //Handle Ajax scenarios
+  if (!empty($form_state['rebuild_info'])) {
+    if (!empty($form_state['captcha_info']['posted_form_id'])) {
+      $posted_form_id = $form_state['captcha_info']['posted_form_id'];
+    }
+    else {
+      $posted_form_id = $form_state['input']['form_id'];
+    }
+
+    $posted_captcha_sid = $form_state['captcha_info']['captcha_sid'];
+  }
+  else if ($form_state['submitted'] && isset($form_state['captcha_info'])) {
     // We are handling (or rebuilding) an already submitted form,
     // so we already determined the posted form ID and CAPTCHA session ID
     // for this form (from before submitting). Reuse this info.
@@ -764,7 +776,7 @@ function captcha_pre_render_process($element) {
   // of multi-page forms. Take previewing a node submission for example:
   // when the challenge is solved correctely on preview, the form is still
   // not completely submitted, but the CAPTCHA can be skipped.
-  if (_captcha_required_for_user($captcha_sid, $form_id) || $element['#captcha_admin_mode']) {
+  if (_captcha_required_for_user($captcha_sid, $form_id) || $element['#captcha_admin_mode'] || $element['#captcha_always']) {
     // Update captcha_sessions table: store the solution of the generated CAPTCHA.
     _captcha_update_captcha_session($captcha_sid, $captcha_info['solution']);
 
diff --git a/drupal7/sites/all/modules/captcha/captcha.test b/drupal7/sites/all/modules/captcha/captcha.test
index bccefe37..41b6ab0c 100644
--- a/drupal7/sites/all/modules/captcha/captcha.test
+++ b/drupal7/sites/all/modules/captcha/captcha.test
@@ -60,7 +60,11 @@ abstract class CaptchaBaseWebTestCase extends DrupalWebTestCase {
 
   function setUp() {
     // Load two modules: the captcha module itself and the comment module for testing anonymous comments.
-    parent::setUp('captcha', 'comment');
+    $modules = func_get_args();
+    if (isset($modules[0]) && is_array($modules[0])) {
+      $modules = $modules[0];
+    }
+    parent::setUp(array_merge(array('captcha', 'comment'), $modules));
     module_load_include('inc', 'captcha');
 
     // Create a normal user.
@@ -602,16 +606,16 @@ class CaptchaAdminTestCase extends CaptchaBaseWebTestCase {
     // Set CAPTCHA on user register form.
     captcha_set_form_id_setting('user_register', 'captcha/Math');
 
-    // Put Javascript snippet in CAPTCHA description.
+    // Put JavaScript snippet in CAPTCHA description.
     $this->drupalLogin($this->admin_user);
     $xss = '<script type="text/javascript">alert("xss")</script>';
     $edit = array('captcha_description' => $xss);
     $this->drupalPost(self::CAPTCHA_ADMIN_PATH, $edit, 'Save configuration');
 
-    // Visit user register form and check if Javascript snippet is there.
+    // Visit user register form and check if JavaScript snippet is there.
     $this->drupalLogout();
     $this->drupalGet('user/register');
-    $this->assertNoRaw($xss, 'Javascript should not be allowed in CAPTCHA description.', 'CAPTCHA');
+    $this->assertNoRaw($xss, 'JavaScript should not be allowed in CAPTCHA description.', 'CAPTCHA');
 
   }
 
diff --git a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.admin.inc b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.admin.inc
index f762a9fa..e4c0aeb3 100644
--- a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.admin.inc
+++ b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.admin.inc
@@ -14,7 +14,7 @@ function image_captcha_settings_form() {
 
   // Add CSS for theming of admin form.
   $form['#attached']['css'] = array(drupal_get_path('module', 'image_captcha') . '/image_captcha.css');
-  // Use javascript for some added usability on admin form.
+  // Use JavaScript for some added usability on admin form.
   $form['#attached']['js'] = array(drupal_get_path('module', 'image_captcha') . '/image_captcha.js');
 
   // First some error checking.
diff --git a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.info b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.info
index 67ce7aa4..7fdca543 100644
--- a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.info
+++ b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.info
@@ -9,10 +9,11 @@ files[] = image_captcha.install
 files[] = image_captcha.module
 files[] = image_captcha.admin.inc
 files[] = image_captcha.user.inc
+files[] = image_captcha.test
 
-; Information added by Drupal.org packaging script on 2015-03-27
-version = "7.x-1.3"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-1.4"
 core = "7.x"
 project = "captcha"
-datestamp = "1427464219"
+datestamp = "1487198287"
 
diff --git a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.module b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.module
index 207a083b..1fd9c36b 100644
--- a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.module
+++ b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.module
@@ -244,7 +244,7 @@ function image_captcha_captcha($op, $captcha_type = '', $captcha_sid = NULL) {
             'ts' => REQUEST_TIME,
           ),
         );
-        $img_src = check_url(url("image_captcha", $options));
+        $img_src = drupal_strip_dangerous_protocols(url("image_captcha", $options));
         list($width, $height) = _image_captcha_image_size($code);
         $result['form']['captcha_image'] = array(
           '#theme' => 'image',
diff --git a/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.test b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.test
new file mode 100644
index 00000000..6f5d5a3f
--- /dev/null
+++ b/drupal7/sites/all/modules/captcha/image_captcha/image_captcha.test
@@ -0,0 +1,72 @@
+<?php
+
+/**
+ * @file
+ * Tests for the Image CAPTCHA module.
+ */
+
+class ImageCaptchaWebTestCase extends CaptchaBaseWebTestCase {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'General Image CAPTCHA functionality',
+      'description' => 'Testing of the basic Image CAPTCHA functions.',
+      'group' => 'CAPTCHA',
+    );
+  }
+
+  public function setUp() {
+    parent::setUp('image_captcha');
+  }
+
+  /**
+   * Helper function to get the CAPTCHA image element from the current form.
+   */
+  protected function getCaptchaImageFromForm() {
+    $elements = $this->xpath('//input[@name="captcha_sid"]/../img');
+    return $elements[0];
+  }
+
+  /**
+   * Helper function to get a CAPTCHA form.
+   */
+  protected function getImageCaptchaForm($form_id = 'user_login', $page = 'user') {
+    // Set a CAPTCHA on supplied form.
+    captcha_set_form_id_setting($form_id, 'image_captcha/Image');
+
+    // Fetch the page and make sure that we got a CAPTCHA.
+    $this->drupalGet($page);
+    $this->assertCaptchaPresence(TRUE);
+  }
+
+  /**
+   * Asserts that the image URL actually returns an image.
+   */
+  protected function assertNonEmptyImage() {
+    $img = $this->getCaptchaImageFromForm();
+
+    // Try to fetch the image.
+    $this->drupalGet($this->getAbsoluteUrl($img['src']));
+    $this->assertTrue($this->drupalGetHeader('Content-Length') > 0,
+                      'Image CAPTCHA image is not empty.');
+  }
+
+  /**
+   * Tests if the image URL actually returns an image with clean URLs enabled.
+   */
+  public function testNonEmptyImageCleanURLs() {
+    variable_set('clean_url', 1);
+    $this->getImageCaptchaForm();
+    $this->assertNonEmptyImage();
+  }
+
+  /**
+   * Tests if the image URL actually returns an image with clean URLs disabled.
+   */
+  public function testNonEmptyImageDirtyURLs() {
+    variable_set('clean_url', 0);
+    $this->getImageCaptchaForm();
+    $this->assertNonEmptyImage();
+  }
+
+}
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConf.class.php b/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConf.class.php
index 15abe301..4b3bc321 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConf.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConf.class.php
@@ -303,7 +303,7 @@ class LdapAuthenticationConf {
 
     $this->ldapUser = new LdapUserConf();
     $this->ssoEnabled = module_exists('ldap_sso');
-    $this->apiPrefs['requireHttps'] = variable_get('ldap_servers_require_ssl_for_credentails', 0);
+    $this->apiPrefs['requireHttps'] = variable_get('ldap_servers_require_ssl_for_credentials', 0);
     $this->apiPrefs['encryption'] = variable_get('ldap_servers_encryption', LDAP_SERVERS_ENC_TYPE_CLEARTEXT);
 
   }
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConfAdmin.class.php b/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConfAdmin.class.php
index 59a5d36e..21f9493d 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConfAdmin.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/LdapAuthenticationConfAdmin.class.php
@@ -69,9 +69,9 @@ class LdapAuthenticationConfAdmin extends LdapAuthenticationConf {
     */
 
     $values['emailOptionOptions'] = array(
-      LDAP_AUTHENTICATION_EMAIL_FIELD_REMOVE => t('Don\'t show an email field on user forms.  LDAP derived email will be used for user and connot be changed by user'),
-      LDAP_AUTHENTICATION_EMAIL_FIELD_DISABLE => t('Show disabled email field on user forms with LDAP derived email.  LDAP derived email will be used for user and connot be changed by user'),
-      LDAP_AUTHENTICATION_EMAIL_FIELD_ALLOW => t('Leave email field on user forms enabled.  Generally used when provisioning to LDAP or not using email derived from LDAP.'),
+      LDAP_AUTHENTICATION_EMAIL_FIELD_REMOVE => t('Don\'t show an email field on user forms. LDAP derived email will be used for user and cannot be changed by user.'),
+      LDAP_AUTHENTICATION_EMAIL_FIELD_DISABLE => t('Show disabled email field on user forms with LDAP derived email. LDAP derived email will be used for user and cannot be changed by user.'),
+      LDAP_AUTHENTICATION_EMAIL_FIELD_ALLOW => t('Leave email field on user forms enabled. Generally used when provisioning to LDAP or not using email derived from LDAP.'),
       );
 
     $values['emailUpdateOptions'] = array(
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
index 68b45c19..fa835ecb 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.inc
@@ -461,7 +461,7 @@ function _ldap_authentication_user_login_authenticate_validate(&$form_state, $re
 
     // don't pass in ldap user to provisionDrupalAccount, because want to requery with correct attributes needed
     // this may be a case where efficiency dictates querying for all attributes
-    $drupal_account = $auth_conf->ldapUser->provisionDrupalAccount(NULL, $user_edit, NULL, TRUE);
+    $drupal_account = $auth_conf->ldapUser->provisionDrupalAccount(NULL, $user_edit, $ldap_user, TRUE);
 
     if ($drupal_account === FALSE) {
       watchdog('ldap_user', 'Failed to find or create %drupal_accountname on logon.', $watchdog_tokens, WATCHDOG_ERROR);
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
index 7e3073a7..610261fc 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.info
@@ -14,9 +14,9 @@ files[] = ldap_authentication.theme.inc
 files[] = ldap_authentication.admin.inc
 files[] = tests/ldap_authentication.test
 
-; Information added by Drupal.org packaging script on 2016-08-07
-version = "7.x-2.0-beta11"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-2.0-beta12"
 core = "7.x"
 project = "ldap"
-datestamp = "1470608343"
+datestamp = "1487199794"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
index b586b73b..d60aa39e 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.module
@@ -81,7 +81,7 @@ function ldap_authentication_menu() {
     'type' => MENU_CALLBACK,
     'file' => 'ldap_authentication.pages.inc',
   );
-  
+
   $items['admin/config/people/ldap/authentication'] = array(
     'title' => 'Authentication',
     'description' => 'Configure LDAP Authentication',
@@ -183,13 +183,13 @@ function ldap_authentication_help($path, $arg) {
 /**
  * Helper function that determines whether or not the user's profile
  * is valid or needs to be updated on login.
- * 
+ *
  * Currently this only checks if mail is valid or not according to the
  * authentication settings.
- * 
+ *
  * @return boolean
  *   TRUE if the user's profile is valid, otherwise FALSE.
- * 
+ *
  */
 function _ldap_authentication_verify_user_profile() {
   global $user;
@@ -262,17 +262,15 @@ function ldap_authentication_info($field = 0) {
 
 
 /**
+ * Determines if the passed user has a valid authmap record.
  *
  * @param object $user
+ *   A drupal user account.
+ *
  * @return boolean
  *    true if user is recorded as ldap authenticated and identified (ldap_authentified)
  */
-
 function ldap_authentication_ldap_authenticated($user) {
-
-  if (is_numeric($user)) {
-    $user = @user_load((int)$user);
-  }
   if (!is_object($user) || $user->uid == 0) {
     return FALSE;
   }
@@ -321,7 +319,7 @@ function ldap_authentication_ldap_server_in_use($sid, $server_name) {
 
   $use_warnings = array();
   $auth_conf = ldap_authentication_get_valid_conf();
-  if ($auth_conf && in_array($sid, array_keys($auth_conf->sids))) {
+  if ($auth_conf && in_array($sid, array_keys($auth_conf->sids)) && !empty($auth_conf->sids[$sid])) {
     $use_warnings[] = t('This server (%server_name) may not be deleted or
       disabled because it is being used for ldap authentication.',
       array('%server_name' => $server_name));
@@ -335,7 +333,9 @@ function ldap_authentication_show_reset_pwd($user = NULL) {
     global $user;
   }
   $auth_conf = ldap_authentication_get_valid_conf();
-  if (current_path() == 'user/password' || $user->uid == 1 || !$auth_conf) {
+  // Hide user/password form if ldap authentication is required and deny access
+  // to users without ldap authorizations is enabled
+  if ($user->uid == 1 || $auth_conf || (current_path() == 'user/password' && $auth_conf->authenticationMode != LDAP_AUTHENTICATION_EXCLUSIVE)) {
     return TRUE;
    // always show at user/passwordurl. otherwise user 1 will not be able to reset password.
   }
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.rules.inc b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.rules.inc
index edba9315..aa127ca3 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.rules.inc
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/ldap_authentication.rules.inc
@@ -12,7 +12,8 @@ function ldap_authentication_rules_event_info() {
     'ldap_user_created' => array(
       'label' => t('User created from LDAP entry'),
       'module' => 'ldap_authentication',
-      'arguments' => array(
+      'group' => t('User'),
+      'variables' => array(
         'user' => array(
           'type' => 'user',
           'label' => t('The user created.'),
diff --git a/drupal7/sites/all/modules/ldap/ldap_authentication/tests/ldap_authentication.test b/drupal7/sites/all/modules/ldap/ldap_authentication/tests/ldap_authentication.test
index 6e498cb6..94fe308f 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authentication/tests/ldap_authentication.test
+++ b/drupal7/sites/all/modules/ldap/ldap_authentication/tests/ldap_authentication.test
@@ -391,7 +391,8 @@ class LdapAuthenticationTestCase extends LdapTestCase {
               $this->ldapTestId = "testSSO._SERVER-key=$server_var_key sso_name=$sso_name path=$test_path ldapImplementation=$ldapImplementation seamlessLogin=$seamlessLogin";
               $ldapAuthenticationConf = $this->setSsoServerEnvironment($server_var_key, $sso_name, $ldapImplementation, $seamlessLogin);
               $this->drupalGet($test_path);
-              $this->assertText(t('Member for'), 'Successful logon.', $this->ldapTestId);
+              // @FIXME: Broken test
+              // $this->assertText(t('Member for'), 'Successful logon.', $this->ldapTestId);
               $this->drupalGet('user/logout');
             }
           }
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/LdapAuthorizationConsumerConfAdmin.class.php b/drupal7/sites/all/modules/ldap/ldap_authorization/LdapAuthorizationConsumerConfAdmin.class.php
index 0684de70..07050933 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/LdapAuthorizationConsumerConfAdmin.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/LdapAuthorizationConsumerConfAdmin.class.php
@@ -132,7 +132,7 @@ class LdapAuthorizationConsumerConfAdmin extends LdapAuthorizationConsumerConf {
 
     $form['status']['only_ldap_authenticated'] = array(
       '#type' => 'checkbox',
-      '#title' => t('Only apply the following LDAP to !consumer_name configuration to users authenticated via LDAP.  On uncommon reason for disabling this is when you are using Drupal authentication, but want to leverage LDAP for authorization; for this to work the Drupal username still has to map to an LDAP entry.', $consumer_tokens),
+      '#title' => t('Only apply the following LDAP to !consumer_name configuration to users authenticated via LDAP.  One uncommon reason for disabling this is when you are using Drupal authentication, but want to leverage LDAP for authorization; for this to work the Drupal username still has to map to an LDAP entry.', $consumer_tokens),
       '#default_value' =>  $this->onlyApplyToLdapAuthenticated,
     );
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
index 7e8c14ec..a987d7f2 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization.info
@@ -14,13 +14,12 @@ files[] = ldap_authorization.admin.inc
 files[] = ldap_authorization.admin.test.inc
 files[] = ldap_authorization.theme.inc
 files[] = tests/BasicTests.test
-files[] = tests/Og1Tests.test
 files[] = tests/Og2Tests.test
 configure = admin/config/people/ldap/authorization
 
-; Information added by Drupal.org packaging script on 2016-08-07
-version = "7.x-2.0-beta11"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-2.0-beta12"
 core = "7.x"
 project = "ldap"
-datestamp = "1470608343"
+datestamp = "1487199794"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
index a0caeb21..f49df6c6 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_drupal_role/ldap_authorization_drupal_role.info
@@ -9,9 +9,9 @@ files[] = LdapAuthorizationConsumerRole.class.php
 files[] = ldap_authorization_drupal_role.module
 files[] = ldap_authorization_drupal_role.inc
 
-; Information added by Drupal.org packaging script on 2016-08-07
-version = "7.x-2.0-beta11"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-2.0-beta12"
 core = "7.x"
 project = "ldap"
-datestamp = "1470608343"
+datestamp = "1487199794"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/LdapAuthorizationConsumerOG.class.php b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/LdapAuthorizationConsumerOG.class.php
index 8855b1d1..ef192518 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/LdapAuthorizationConsumerOG.class.php
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/LdapAuthorizationConsumerOG.class.php
@@ -585,7 +585,13 @@ class LdapAuthorizationConsumerOG extends LdapAuthorizationConsumerAbstract {
 
     $user_edit = array('data' => $user->data);
     $user_edit['data']['ldap_authorizations'][$this->consumerType] = $user_auth_data;
+    // Force a reload of the user object, since changes made through the grant-
+    // and revoke-functions above might have changed og-related field data.
+    // Those changes will not yet be reflected in $user, potentially causing
+    // data loss when user_save() is called with stale data.
+    $user = user_load($user->uid, TRUE);
     $user = user_save($user, $user_edit);
+
     $user_auth_data = $user->data['ldap_authorizations'][$this->consumerType];  // reset this variable because user save hooks can impact it.
 
     $this->flushRelatedCaches($consumers, $user);
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
index 48640585..394d1ab6 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/ldap_authorization_og/ldap_authorization_og.info
@@ -13,9 +13,9 @@ files[] = ldap_authorization_og.inc
 
 core = "7.x"
 
-; Information added by Drupal.org packaging script on 2016-08-07
-version = "7.x-2.0-beta11"
+; Information added by Drupal.org packaging script on 2017-02-15
+version = "7.x-2.0-beta12"
 core = "7.x"
 project = "ldap"
-datestamp = "1470608343"
+datestamp = "1487199794"
 
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/tests/BasicTests.test b/drupal7/sites/all/modules/ldap/ldap_authorization/tests/BasicTests.test
index a8e58df3..cf67f170 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/tests/BasicTests.test
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/tests/BasicTests.test
@@ -226,11 +226,13 @@ function testFlags() {
   $roles2 = isset($new_authorizations['drupal_role']) ? $new_authorizations['drupal_role'] : array();
   $correct_roles = (count($roles1) > 0 && count($roles2) == 0); // not worried about which roles here, just that some are granted
 
+  /** @FIXME: Broken test
   $this->assertTrue(
     $correct_roles,
     'disable consumer configuration disallows authorizations.',
     'LDAP_authorz.Flags.status.0'
   );
+   */
   if (!$correct_roles) {
     debug('LDAP_authorz.Flags.enable.0 roles with enabled'); debug($roles1);
     debug('LDAP_authorz.Flags.enable.0 roles with disabled'); debug($roles2);
@@ -468,6 +470,8 @@ function testFlags() {
 }
 
   public function testUIForms() {
+    // TODO: Fix failing tests, excluding to make branch pass.
+    return;
 
     $ldap_simpletest_initial = variable_get('ldap_simpletest', 2);
     variable_del('ldap_simpletest'); // need to be out of fake server mode to test ui.
diff --git a/drupal7/sites/all/modules/ldap/ldap_authorization/tests/Og2Tests.test b/drupal7/sites/all/modules/ldap/ldap_authorization/tests/Og2Tests.test
index 2f336490..e97977c7 100644
--- a/drupal7/sites/all/modules/ldap/ldap_authorization/tests/Og2Tests.test
+++ b/drupal7/sites/all/modules/ldap/ldap_authorization/tests/Og2Tests.test
@@ -127,6 +127,8 @@ class LdapAuthorizationOg2Tests extends LdapTestCase {
    * just make sure install succeeds and
    */
   function testBasicFunctionsAndApi() {
+    // TODO: Fix failing tests, excluding to make branch pass.
+    return;
 
     if (ldap_authorization_og_og_version() != 2) {
       debug('LdapAuthorizationOg2Tests must be run with OG 7.x-2.x');
@@ -300,6 +302,8 @@ class LdapAuthorizationOg2Tests extends LdapTestCase {
  */
 
 function testFlags() {
+  // TODO: Fix failing tests, excluding to make branch pass.
+  return;
 
   $sid = 'activedirectory1';
   $this->prepTestData(
